/*
 * author: Darren Bounds <dbounds@intrusense.com>
 * copyright: Copyright (C) 2002 by Darren Bounds
 * license: This software is under GPL version 2 of license
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * packit official page at http://packit.sourceforge.net
 */

#include "../include/packit.h" 
#include "../include/inject.h"
#include "../include/capture.h"
#include "../include/error.h"

libnet_t *packet_d;

int
reset_tcp_stream(unsigned char *packet, struct libnet_ipv4_hdr *iphdr)
{
    int rst_flags = 0;
    unsigned char *s_addr, *d_addr;

    struct libnet_tcp_hdr *tcphdr;

#ifdef __DEBUG
    fprintf(stderr, "DEBUG: reset_tcp_stream()\n");
#endif

    tcphdr = (struct libnet_tcp_hdr *)(packet + PACKIT_IPV4_H + header_len);

    if(!(tcphdr->th_flags & TH_ACK) || !(tcphdr->th_flags & TH_SYN))
	return 0;

    rst_flags |= TH_RST;
    
    if((packet_d = libnet_init(0x01, device, errbuf)) == NULL)
    {
        fprintf(stderr, "\nError: Unable to initialize packet injection: %s\n", errbuf);
        exit(FAILURE);
    }

    if(libnet_build_tcp(
        htons(tcphdr->th_dport), 
        htons(tcphdr->th_sport), 
        ntohl(tcphdr->th_ack), 
        0, 
        TH_RST, 
        0, 
        0, 
        0, 
        PACKIT_TCP_H, 
        NULL, 
        0, 
        packet_d, 
        0) == -1)
    {
        fprintf(stderr, "\nError: Unable to build TCP header: %s\n", libnet_geterror(packet_d)); 
        exit(FAILURE);
    } 

    if(libnet_build_ipv4(
        PACKIT_IPV4_H + PACKIT_TCP_H,
        IPTOS_LOWDELAY,
        libnet_get_prand(LIBNET_PRu16),
        0,
        255,
        IPPROTO_TCP,
        0,
        iphdr->ip_dst.s_addr,
        iphdr->ip_src.s_addr,
        NULL,
        0,
        packet_d,
        0) == -1)
    {
        fprintf(stderr, "\nError: Unable to build IP header: %s\n", libnet_geterror(packet_d));
        exit(FAILURE);
    }

    if(libnet_write(packet_d) == -1)
    {
        fprintf(stderr, "\nError: Unable to write packet to network: %s\n", libnet_geterror(packet_d));
        exit(FAILURE);
    }

    libnet_clear_packet(packet_d);

    s_addr = libnet_addr2name4(iphdr->ip_src.s_addr, 0);
    d_addr = libnet_addr2name4(iphdr->ip_dst.s_addr, 0);

    fprintf(stdout, "Src Address: %s.%d > Dst Address: %s.%d: R ", 
        d_addr,
	htons(tcphdr->th_dport),
	s_addr,
	htons(tcphdr->th_sport)); 

#ifdef __LINUX
    fprintf(stdout, "Seqn: %u", ntohl(tcphdr->th_ack));
#else
    fprintf(stdout, "Seqn: %lu", ntohl(tcphdr->th_ack));
#endif /* __LINUX */

    fprintf(stdout, "\n");

    return 1;
}
